#include <nall/config.hpp>
#include <nall/windows/launcher.hpp>
using namespace nall;

struct Configuration : public configuration {
  string applicationName;
  string libraryName;
  unsigned entryPoint;

  void load() {
    attach(applicationName = "", "applicationName");
    attach(libraryName = "", "libraryName");
    attach(entryPoint = 0x401000, "entryPoint");
    configuration::load("launcher.cfg");
    configuration::save("launcher.cfg");
  }
} config;

int main(int argc, char **argv) {
  char path[PATH_MAX + 1];
  _fullpath(path, argv[0], PATH_MAX);
  _chdir(dir(path));
  config.load();

  if(launch(config.applicationName, config.libraryName, config.entryPoint) == false) {
    MessageBoxW(0, L"Error: launcher failed to load.\n\nPlease check settings in launcher.cfg", L"launcher", MB_OK);
  }

  return 0;
}
