#include <nall/any.hpp>
#include <nall/array.hpp>
#include <nall/concept.hpp>
#include <nall/config.hpp>
#include <nall/dictionary.hpp>
#include <nall/directory.hpp>
#include <nall/dl.hpp>
#include <nall/file.hpp>
#include <nall/filemap.hpp>
#include <nall/foreach.hpp>
#include <nall/function.hpp>
#include <nall/input.hpp>
#include <nall/priorityqueue.hpp>
#include <nall/public_cast.hpp>
#include <nall/reference_array.hpp>
#include <nall/serializer.hpp>
#include <nall/stack.hpp>
#include <nall/static.hpp>
#include <nall/stdint.hpp>
#include <nall/string.hpp>
#include <nall/utility.hpp>
#include <nall/varint.hpp>
#include <nall/vector.hpp>
#include <nall/snes/cpu.hpp>
#include <nall/snes/smp.hpp>
#include <nall/snes/cartridge.hpp>
#include <nall/gameboy/cartridge.hpp>
using namespace nall;

/*
    "#?*",
    "?*,s",
    "(?*,s),y",
    "(?*,x)",
    "(?*),y",
    "(?*)",
    "[?*],y",
    "[?*]",
    "?*,x",
    "?*,y",
    "?*,?*",
    "?*",
*/

int main(int argc, char **argv) {
  lstring list = {
    "",
    "?*",
    "?*.?*",
    "?*.?,?*",
/*
    "?*",
    "?*,?*",
    "?*,s",
    "?*,x",
    "?*,y",
    "(?*,x)",
    "(?*)",
    "(?*),y",
    "(?*,s),y",
    "[?*]",
    "[?*],y",
    "#?*",
*/
  };

  for(unsigned x = 0; x < list.size(); x++) {
    for(unsigned y = 0; y < list.size(); y++) {
      if(x == y) continue;
      if(list[x].wildcard(list[y])) swap(list[x], list[y]);
    }
  }

  print(wildcard("?*.?,?*", "?*.?*"), "\n");

  foreach(item, list) print(item, "\n");

  return 0;
}
